/***************************************************************************************
 * NAME	: SerialAD.cpp
 * DATE	: 7/3/2003
 * PRGR	: Y. Bai - Copyright 2003 - 2007
 * DESC	: Serial port interface program to communicate with a serial A/D converter 
 *        (TLC-548) using C code
 **************************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <string.h>

#define	COM1	0x3F8
#define	COM2	0x2F8
#define BYTE	unsigned char
#define USHORT	unsigned short

void Port_Init(USHORT c1, USHORT c2);
BYTE Port_Read(USHORT r1, USHORT r2, USHORT r3);
void delay(int num);

void main()
{
	FILE*  fp;
	BYTE   value[100];
	USHORT MCR, LCR, MSR;
	MCR = COM1 + 4; LCR = COM1 + 3; MSR = COM1 + 6;

	int index;

	fp = fopen("C:\\SData\\Serial.dat", "w");
	if (fp == NULL)
	{
		printf("Error in open the file...\n");
		return;
	}

	Port_Init(MCR, LCR);
	for (index = 0; index < 100; index++)
	{
		value[index] = Port_Read(MCR, LCR, MSR);
	    printf("The returned value is: %d\n", value[index]);
		fprintf(fp, "%d\n", value[index]);
	}
	fclose(fp);
	Port_Init(MCR, LCR);
	
	return;
}
void Port_Init(USHORT c1, USHORT c2)
{
	printf("Initializing the port...\n");
	_outp(c1, 3);	//make DTR to supplt power/set CS to 1
	_outp(c2, 0);	//set clock to 0
	return;
}
BYTE Port_Read(USHORT r1, USHORT r2, USHORT r3)
{
	int  index;
	BYTE value = 0, bValue;

	_outp(r1, 1);				//reset RTS to activate CS
	for (index = 0; index < 8; index++)
	{
		value = value << 1;
		_outp(r2, 0x40);		//clock high
		_outp(COM1, 0xff);		//sometimes you need this line to activate the TLC-548
		bValue = _inp(r3);	
		if (bValue & 0x10)
		{
			value++;
		}
		_outp(r2, 0);			//clock low
	}
	_outp(r1, 3);				//CS high (deselect TLC-548)
	return value;
}
void delay(int num)
{
	int nn, mm = 1000;
	for (nn = 0; nn < num * 100; nn++)
		mm = mm--;
	return;
}

