
/*****************************************************************************************
 * NAME	: SerialComms.h
 * DATE	: 7/16/2003
 * PGMR	: Y. Bai  Copyright 2003 - 2007
 * DESC	: Header file for the serial communication between two computers(SerialCommEmbs.cpp)
 *****************************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <math.h>
#include <time.h>

#define		MAXNUM		100				// Max data length
#define     BYTE        unsigned char	// Data type
#define		USHORT		unsigned short
#define     T			50				// Sine/cos signals period	
#define		A			10				// Sine/cos signal amplitude
#define		TMOUT1		1000			// Time out value for comm_start()
#define		NUMS		20

USHORT	    COM2 = 0x2f8;				// COM2 base address
USHORT	    IER	 = 0x2f9;				// COM2 Interrupt Enable Register
USHORT	    LCR	 = 0x2fb;				// COM2 Line Control Register	
USHORT	    MCR	 = 0x2fc;				// COM2 Modem Control Register
USHORT      LSR	 = 0x2fd;				// COM2 Line Status Register
USHORT      MSR	 = 0x2fe;				// COM2 Modem Status Register

#define		elapsed		((clock() - start)/ CLK_TCK)

bool cosFl = false;
double pi  = 3.14159265;
double ds  = 180/pi;

struct serialDATA
{
	char  pos[64];
	char  ang[64];
};

struct serialSIGNAL
{
	double pos[MAXNUM];
	double ang[MAXNUM];
};

void  sinial();
void  delay(int nums);
BYTE  sends(char c, int nums);
BYTE  reces(int nums);
int   comm_start();
int   comm_collect(serialDATA* res, double spos, double sang);
int   get_index();
void  gen_signal(serialSIGNAL* sgl);
