/********************************************************************************************
 * NAME	: SerialInter.cpp
 * DATE	: 7/18/2003
 * PGMR	: Y. Bai   Copyright 2003 - 2007
 * DESC	: Example interruption program. Each time when user clicks a key, this key is sent
          to the COM1. As soon as COM1 received a character, an interrupt sub will be called
		  to store and display that character.
 * NOTE	: This program can only be compiled by Microsoft C 6.0A or Turbo C++ 1.01.
 ********************************************************************************************/
#include "SerialInter.h"
 
void (_interrupt _far COM1INT)()  /* Interrupt Service Routine (ISR) for COM1 */
{
	BYTE c;
	do {
			c = inportb(LSR);
			if (c & 1) {buffer[bufferin] = inportb(COM1);
				bufferin++;
			if (bufferin == LENGTH - 1) {bufferin = 0;}}
		}while (c & 1);
	outportb(ICR,0x20);
}

void main(void)
{
	BYTE  c;
	outportb(IER, 0);				/* Turn off interrupts - COM1 */

	oldvect = getvect(INTVECT);		/* Save old Interrupt Vector of later recovery */

	setvect(INTVECT, COM1INT);      /* Set Interrupt Vector Entry */
									/* COM1, COM3 - 0x0C (Interrupt vector 12) */
									/* COM2, COM4 - 0x0B (Interrupt vector 11) */
//  PORT 1 - Communication Settings       
	outportb(LCR,  0x80);			/* SET DLAB ON */
	outportb(COM1, 0x0C);			/* Set Baud rate - Divisor Latch Low Byte */
									/* Default 0x0C = 9,600 BPS */						
	outportb(IER,  0x00);			/* Set Baud rate - Divisor Latch High Byte */
	outportb(LCR,  0x03);			/* 8 Bits, No Parity, 1 Stop Bit */
	outportb(FIFO, 0xC7);			/* FIFO Control Register */
	outportb(MCR,  0x0B);			/* Turn on DTR, RTS, and OUT2 */

	outportb(IMR,(inportb(IMR) & 0xEF));  /* Set Programmable Interrupt Controller */
									/* COM1, COM3 (IRQ4) - 0xEF  */
									/* COM2, COM4 (IRQ3) - 0xF7  */
	outportb(IER, 0x01);			/* Interrupt when data received */

	printf("\nProgram running... Press ESC to quit \n");
	do{

		if (bufferin != bufferout)
		{
			rc = buffer[bufferout];
			bufferout++;
			if (bufferout == LENGTH - 1) {bufferout = 0;}
			printf("%c",rc);
		}
		if (kbhit())
		{	
			c = getch();
			outportb(COM1, c);
		}
	}while (c !=27);					    /* 27 is equivalent to ESC */

	outportb(IER, 0);						/* Turn off interrupts - Port1 */
	outportb(IMR,(inportb(IMR) | 0x10));	/* MASK IRQ using PIC */
											/* COM1, COM3 (IRQ4) - 0x10  */
											/* COM2, COM4 (IRQ3) - 0x08  */
	setvect(INTVECT, oldvect);				/* Restore old interrupt vector */
	return;
}
