/********************************************************************************************
 * NAME	: SerialInter.h
 * DATE	: 7/18/2003
 * PGMR	: Y. Bai   Copyright 2003 - 2007
 * DESC	: Example interruption program. Each time when user clicks a key, this key is sent
          to the COM1. As soon as COM1 received a character, an interrupt sub will be called
		  to store and display that character.
 * NOTE	: This program can only be compiled by Microsoft C 6.0A or Turbo C++ 1.01.
 ********************************************************************************************/
#include <dos.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <process.h>

#define		inportb		_inp
#define		outportb	_outp
#define		getvect		_dos_getvect
#define		setvect		_dos_setvect
#define		LENGTH		1025
#define		INTVECT		0x0C			/* Com Port's IRQ here (Must also change PIC setting) */

#define		USHORT		unsigned short
#define		BYTE		unsigned char
#define		ICR			0x20
#define		IMR			0x21			

USHORT	    COM1 = 0x3f8;				// COM1 base address
USHORT	    IER	 = 0x3f9;				// COM1 Interrupt Enable Register
USHORT		FIFO = 0x3fa;				// COM1 FIFO buffer
USHORT	    LCR	 = 0x3fb;				// COM1 Line Control Register	
USHORT	    MCR	 = 0x3fc;				// COM1 Modem Control Register
USHORT      LSR	 = 0x3fd;				// COM1 Line Status Register
USHORT      MSR	 = 0x3fe;				// COM1 Modem Status Register
  
int  bufferin = 0;
int  bufferout = 0;
char rc;
char buffer[LENGTH];
unsigned long  oldvect;

void (_interrupt _far *oldvect)();
void (_interrupt _far COM1INT)();