/********************************************************************************
 * NAME	: DoublePorts.h
 * DESC	: Header file for DoublePorts.cpp
 * DATE	: 7/24/2002
 * PGMR	: Y. Bai
 ********************************************************************************/
#ifndef DOUBLEPORTS_H_
#define DOUBLEPORTS_H_

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include "Error.h"

#define MAX_MENU				4
#define MAX_STRING				256
#define NOPARITY				0
#define ONESTOPBIT				0
#define RTS_CONTROL_DISABLE     0x00
#define RTS_CONTROL_ENABLE      0x01
#define DTR_CONTROL_DISABLE     0x00
#define DTR_CONTROL_ENABLE      0x01

#define msg(info)	MessageBox(NULL, info, "", MB_OK)

typedef struct
{
    unsigned long   ulCtrlerID;
    char            cEcho;
    char            cEORChar;
    long            lTimeout;
    long            lBaudRate;
    long            lDataBits;
	HANDLE          hPort;
}SerialCreate, *pSerialCreate;
		
typedef struct
{
    char   *pcBuffer; 
	BYTE   bByte;
    int    iMaxChars;         
    int    piNumRcvd;          
	char   cTermChar;	
	HANDLE handlePort;
}CommPortClass;

typedef struct
{
	char   sComPort[16];
	char   rComPort[16];
}PortName, *pPortName;

ERR_CODE PortInitialize(LPTSTR lpszPortName, pSerialCreate pCreate);
ERR_CODE PortWrite(HANDLE handPort, BYTE bByte, int NumByte);
ERR_CODE PortRead(CommPortClass *hCommPort);
void WINAPI ThreadFunc(void* hCommPorts);

ERR_CODE SetupPort(char* cPort, int pFlg);
ERR_CODE TestPort(char* sPort, char* rPort, BOOL display);
ERR_CODE startPort(pPortName pName);
int getMenuItem(unsigned char mPort, char* ret);
#endif
