// COMDLG.cpp : implementation file
//

#include "stdafx.h"
#include "mfcCOMTest.h"
#include "COMDLG.h"
#include "mfcCOMTestDoc.h"
#include "mfcCOMTestView.h"
#include "LoopDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COMDLG dialog


COMDLG::COMDLG(CWnd* pParent /*=NULL*/)
	: CDialog(COMDLG::IDD, pParent)
{
	//{{AFX_DATA_INIT(COMDLG)
	m_comPort = 1;					// modify this port number as default - Bai.
	m_baudRate = 9600;				// modify this as default baud rate - Bai.
	//}}AFX_DATA_INIT
}


void COMDLG::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COMDLG)
	DDX_Control(pDX, IDC_LABEL, m_resLabel);
	DDX_Control(pDX, IDC_READ_EDIT, m_readData);
	DDX_Control(pDX, IDC_SEND_EDIT, m_sendData);
	DDX_Text(pDX, IDC_PORT_EDIT, m_comPort);
	DDV_MinMaxInt(pDX, m_comPort, 1, 8);
	DDX_Text(pDX, IDC_BAUD_EDIT, m_baudRate);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COMDLG, CDialog)
	//{{AFX_MSG_MAP(COMDLG)
	ON_BN_CLICKED(IDINIT, OnInit)
	ON_BN_CLICKED(IDEXIT, OnExit)
	ON_BN_CLICKED(IDTEST, OnTest)
	ON_BN_CLICKED(IDLOOP, OnLoop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COMDLG message handlers

BOOL COMDLG::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	InitFlg = false;
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COMDLG::OnInit() 
{
	// TODO: Add your control notification handler code here
	ERR_CODE  ecRet = OK;
	CMfcCOMTestView*  comView = getComView();
	ASSERT_VALID(comView);
    
	UpdateData(TRUE); 
	ecRet = comView->SetupPort(m_comPort, m_baudRate);
	if (ecRet)
	{
		msg("ERROR in INIT");
		return;
	}
	InitFlg = true;
	m_resLabel.SetWindowText("The Port has been Initialized");
}

void COMDLG::OnTest() 
{
	// TODO: Add your control notification handler code here
	ERR_CODE  ecRet = OK;
	CMfcCOMTestView*  comView = getComView();

	if (!InitFlg)
	{
		msg("No Initialization !");
		return;
	}
	m_resLabel.SetWindowText("");
	UpdateData(TRUE);
	ecRet = comView->TestPort(m_comPort);
	if (ecRet)
		msg("ERROR in TEST");

	if (comView->TestPassed)
		m_resLabel.SetWindowText("Testing is Successful!");
}

void COMDLG::OnLoop() 
{
	// TODO: Add your control notification handler code here
	int  Numloop;
	ERR_CODE  ecRet = OK;
	CMfcCOMTestView*  comView = getComView();

	if (!InitFlg)
	{
		msg("No Initialization !");
		return;
	}
	m_resLabel.SetWindowText("");
	LoopDlg  lpDlg;
	UpdateData(TRUE);

	if (lpDlg.DoModal() == IDOK)
	{
		lpDlg.UpdateWindow();
		for (Numloop = 0; Numloop < lpDlg.m_loopNum; Numloop++)
		{
			ecRet = comView->TestPort(m_comPort);
			if (ecRet)
				msg("ERROR in TEST");
		}
		m_resLabel.SetWindowText("Loop Testing is Successful!");
	}
}

void COMDLG::OnExit() 
{
	// TODO: Add your control notification handler code here
	CMfcCOMTestView*  comView = getComView();

	InitFlg = false;
	CloseHandle(comView->hPort);
	CDialog::OnOK();
}

void COMDLG::setComView(CMfcCOMTestView *comView)
{
	sView = comView;
}

CMfcCOMTestView* COMDLG::getComView()
{
	return sView;
}
