// mfcCOMTestDoc.h : interface of the CMfcCOMTestDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MFCCOMTESTDOC_H__32EB7F5E_AFC6_4429_BE2C_637C2160A902__INCLUDED_)
#define AFX_MFCCOMTESTDOC_H__32EB7F5E_AFC6_4429_BE2C_637C2160A902__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define NUM_BYTE				1
#define MAX_BYTE				90
#define START_BYTE				48
#define	BAUD_RATE				9600
#define	NUM_BITS				8
#define	TIME_OUT				3000
#define MAX_MENU				9
#define MAX_STRING				256
#define NOPARITY				0
#define ONESTOPBIT				0
#define RTS_CONTROL_DISABLE     0x00
#define RTS_CONTROL_ENABLE      0x01
#define DTR_CONTROL_DISABLE     0x00
#define DTR_CONTROL_ENABLE      0x01

#define msg(info)  AfxMessageBox(info)

typedef struct
{
    unsigned long   ulCtrlerID;
    char            cEcho;
    char            cEORChar;
    long            lTimeout;
    long            lBaudRate;
    long            lDataBits;
	HANDLE          h_Port;
}SerialCreate, *pSerialCreate;
		
typedef struct
{
    char   *pcBuffer; 
	BYTE   bByte;
    int    iMaxChars;         
    int    piNumRcvd;          
	char   cTermChar;	
	HANDLE handlePort;
}CommPortClass;

typedef enum
{
    OK					= 0,		 /* no error */
    EC_TIMEOUT,
	EC_FOPEN,
	EC_INVAL_CONFIG,
	EC_TIMEOUT_SET,
	EC_RECV_TIMEOUT,
	EC_EXIT_CODE,
	EC_WAIT_SINGLEOBJ,
	EC_INVALIDPORT,
	EC_WRITE_FAIL,
	EC_READ_FAIL,
	EC_TEST_FAIL,
	EC_CREATE_THREAD,
	EC_PORT_INITDONE,	
	EC_UNKNOWNERROR
}ERR_CODE;

class CMfcCOMTestDoc : public CDocument
{
protected: // create from serialization only
	CMfcCOMTestDoc();
	DECLARE_DYNCREATE(CMfcCOMTestDoc)

// Attributes
public:
	
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMfcCOMTestDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	ERR_CODE PortInitialize(LPTSTR lpszPortName, pSerialCreate pCreate);
	ERR_CODE PortRead(CommPortClass* hCommPorts);
	ERR_CODE PortWrite(HANDLE handPort, BYTE bByte, int NumByte);
	virtual ~CMfcCOMTestDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMfcCOMTestDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MFCCOMTESTDOC_H__32EB7F5E_AFC6_4429_BE2C_637C2160A902__INCLUDED_)
