// mfcCOMTestView.cpp : implementation of the CMfcCOMTestView class
//

#include "stdafx.h"
#include "mfcCOMTest.h"
#include "COMDLG.h"
#include "mfcCOMTestDoc.h"
#include "mfcCOMTestView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

char*  comPORT[] = { {"COM1"}, {"COM2"}, {"COM3"}, {"COM4"}, {"COM5"},
                     {"COM6"}, {"COM7"}, {"COM8"}, {"COM9"}};           
/////////////////////////////////////////////////////////////////////////////
// CMfcCOMTestView

IMPLEMENT_DYNCREATE(CMfcCOMTestView, CView)

BEGIN_MESSAGE_MAP(CMfcCOMTestView, CView)
	//{{AFX_MSG_MAP(CMfcCOMTestView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMfcCOMTestView construction/destruction

CMfcCOMTestView::CMfcCOMTestView()
{
	// TODO: add construction code here
	comDlg = new COMDLG;

	hPort = 0;
	TestPassed = FALSE;
	for (int i = 0; i < MAX_MENU; i++)
	PortFlg[i] = false;

	comDlg->setComView(this);
	if (comDlg->DoModal() == IDOK)
		exit (0);

}

CMfcCOMTestView::~CMfcCOMTestView()
{
	delete comDlg;
}

BOOL CMfcCOMTestView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMfcCOMTestView drawing

void CMfcCOMTestView::OnDraw(CDC* pDC)
{
	CMfcCOMTestDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CMfcCOMTestView printing

BOOL CMfcCOMTestView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CMfcCOMTestView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CMfcCOMTestView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CMfcCOMTestView diagnostics

#ifdef _DEBUG
void CMfcCOMTestView::AssertValid() const
{
	CView::AssertValid();
}

void CMfcCOMTestView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMfcCOMTestDoc* CMfcCOMTestView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMfcCOMTestDoc)));
	return (CMfcCOMTestDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMfcCOMTestView message handlers

ERR_CODE CMfcCOMTestView::SetupPort(int nPort, int nBaud)
{
	int portNum;
	ERR_CODE ecRet = OK;
	pSerialCreate  pParam;

	pParam = new SerialCreate;
	portNum = nPort - 1;

	pParam->lBaudRate = nBaud;
	pParam->lDataBits = NUM_BITS;
	pParam->lTimeout  = TIME_OUT;

	CMfcCOMTestDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	if (PortFlg[portNum])
		return ecRet;

	ecRet = pDoc->PortInitialize(comPORT[portNum], pParam);
	if (ecRet != OK)
		msg("ERROR in PortInitialize()!");
	else
	{
		PortFlg[portNum] = TRUE;		// set port init flag as true
		hPort = pParam->h_Port;			// reserve the port handler
	}
	delete pParam;

	return ecRet;
}

ERR_CODE CMfcCOMTestView::TestPort(int cPort)
{
	BYTE   sByte;
	char   sData[16], rData[16];
	int    numByte = NUM_BYTE, MaxByte = MAX_BYTE;
	ERR_CODE ecRet = OK;
	CommPortClass* comPort = new CommPortClass;

	CMfcCOMTestDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	if (!PortFlg[cPort - 1])
	{
		msg("Port not Initialized!");
		return ecRet;
	}
	comPort->handlePort = hPort;
	comPort->iMaxChars  = NUM_BYTE;

	for (sByte = START_BYTE; sByte <= MaxByte; sByte++)
	{
		ecRet = pDoc->PortWrite(hPort, sByte, numByte);
		if (ecRet)
		{
			msg("PortWrite() is failed");
			TestPassed = FALSE;
			return EC_WRITE_FAIL;
		}
		sprintf(sData, "%c", sByte);
		comDlg->m_sendData.SetWindowText(sData);
		comDlg->m_sendData.UpdateWindow();
		//
		ecRet = pDoc->PortRead(comPort);
		if (ecRet)
		{
			msg("PortRead() is failed");
			TestPassed = FALSE;
			return EC_READ_FAIL;
		}
		sprintf(rData, "%c", comPort->bByte);
		comDlg->m_readData.SetWindowText(rData);
		comDlg->m_readData.UpdateWindow();
		//
		if (sByte != comPort->bByte)
		{
			TestPassed = FALSE;
			return EC_TEST_FAIL;
		}
	}
	TestPassed = TRUE;
	delete comPort;

	return ecRet;
}
