// mfcDoublePorts.h : main header file for the MFCDOUBLEPORTS application
//

#if !defined(AFX_MFCDOUBLEPORTS_H__B760A554_4DB1_4101_A061_0CCBAE319D95__INCLUDED_)
#define AFX_MFCDOUBLEPORTS_H__B760A554_4DB1_4101_A061_0CCBAE319D95__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols

void WINAPI ThreadFunc(void* hCommPorts);

/////////////////////////////////////////////////////////////////////////////
// CMfcDoublePortsApp:
// See mfcDoublePorts.cpp for the implementation of this class
//

#define NUM_BYTE				1
#define MAX_BYTE				90
#define START_BYTE				48
#define	BAUD_RATE				9600
#define	NUM_BITS				8
#define	TIME_OUT				3000
#define MAX_MENU				4
#define MAX_STRING				256
#define NOPARITY				0
#define ONESTOPBIT				0
#define RTS_CONTROL_DISABLE     0x00
#define RTS_CONTROL_ENABLE      0x01
#define DTR_CONTROL_DISABLE     0x00
#define DTR_CONTROL_ENABLE      0x01

#define msg(info)	AfxMessageBox(info)

typedef struct
{
    unsigned long   ulCtrlerID;
    char            cEcho;
    char            cEORChar;
    long            lTimeout;
    long            lBaudRate;
    long            lDataBits;
	HANDLE          hPort;
}SerialCreate, *pSerialCreate;
		
typedef struct
{
    char   *pcBuffer; 
	BYTE   bByte;
    int    iMaxChars;         
    int    piNumRcvd;          
	char   cTermChar;	
	HANDLE handlePort;
}CommPortClass;

typedef enum
{
    OK					= 0,		 /* no error */
    EC_TIMEOUT,
	EC_FOPEN,
	EC_INVAL_CONFIG,
	EC_TIMEOUT_SET,
	EC_RECV_TIMEOUT,
	EC_EXIT_CODE,
	EC_WAIT_SINGLEOBJ,
	EC_INVALIDPORT,
	EC_WRITE_FAIL,
	EC_CREATE_THREAD,
	EC_READ_FAIL,
	EC_TEST_FAIL,
	EC_UNKNOWNERROR
}ERR_CODE;

class CMfcDoublePortsApp : public CWinApp
{
public:
	ERR_CODE PortRead(CommPortClass* hCommPort);
	ERR_CODE PortWrite(HANDLE handPort, BYTE bByte, int NumByte);
	ERR_CODE PortInitialize(LPTSTR lpszPortName, pSerialCreate pCreate);
	CMfcDoublePortsApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMfcDoublePortsApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CMfcDoublePortsApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MFCDOUBLEPORTS_H__B760A554_4DB1_4101_A061_0CCBAE319D95__INCLUDED_)
