/****************************************************************************************
 * NAME:	CINReadData.h
 * DESC:	Header file for the CINReadData.cpp
 * PGMR:	Y. Bai
 * DATE:	11/6/2003
 ***************************************************************************************/
#include <Windows.h>
#include "extcode.h"
#ifndef _CINREADDATA_H_
#define _CINREADDATA_H_

#define MAX_BYTE	1
#define MAX_BITS	12	
#define msg(info)	MessageBox(NULL, info, "", MB_OK)

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct
{
    short pcBuffer;           /* store the received 12-bit A/D data */
    int   iMaxChars;          /* number of the maximum characters  */
	int   iMaxBits;           /* number of the maximum bits of a data */
    int   piNumRcvd;          /* number of data received */
	char  cTermChar;		  /* termination character */
} CommPortClass;

typedef enum
{
    OK          = 0,		 /* no error */
    EC_TIMEOUT,
	EC_FOPEN,
	EC_INVAL_CONFIG,
	EC_TIMEOUT_SET,
	EC_RECV_TIMEOUT,
	EC_EXIT_CODE,
	EC_WAIT_SINGLEOBJ,
	EC_INVALIDPORT,
	EC_WRITE_FAIL,
	EC_CREATE_THREAD,
	EC_GETMODSTATUS,
	EC_UNKNOWNERROR
} ERR_CODE;

HANDLE	hPort;

/* local functions */
ERR_CODE PortRead(CommPortClass *hCommPort);
void WINAPI ThreadFunc(void* hCommPorts);
void Delay(int num);

//CINReadData() CIN Function
MgErr CINRun(int16 *DataOutput, int32 *hPortIn, int32 *hPortOut, LVBoolean *flg);
MgErr CINProperties(int32 prop, void *data);

#ifdef __cplusplus
}
#endif  /* __cplusplus */
#endif