/****************************************************************************************
 * NAME:	CINSetup.h
 * DESC:	Header file for the CINSetup.cpp
 * PGMR:	Y. Bai
 * DATE:	11/6/2003
 ***************************************************************************************/
#include <Windows.h>
#include "extcode.h"
#ifndef _CINSETUP_H_
#define _CINSETUP_H_

#define MAX_STRING				256
#define NOPARITY				0
#define ONESTOPBIT				0
#define RTS_CONTROL_DISABLE     0x00
#define RTS_CONTROL_ENABLE      0x01
#define DTR_CONTROL_DISABLE     0x00
#define DTR_CONTROL_ENABLE      0x01

#define UCHAR		unsigned char
#define ULONG		unsigned long
#define msg(info)	MessageBox(NULL, info, "", MB_OK)

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
typedef struct
{
    ULONG   ulCtrlID;
    char    cEcho;
    char    cEORChar;
    long    lTimeout;
    long    lBaudRate;
    long    lDataBits;
} SerialCreate, *pSerialCreate;
		
typedef enum
{
    OK          = 0,		 /* no error */
    EC_TIMEOUT,
	EC_FOPEN,
	EC_INVAL_CONFIG,
	EC_TIMEOUT_SET,
	EC_RECV_TIMEOUT,
	EC_EXIT_CODE,
	EC_WAIT_SINGLEOBJ,
	EC_INVALIDPORT,
	EC_WRITE_FAIL,
	EC_CREATE_THREAD,
	EC_GETMODSTATUS,
	EC_UNKNOWNERROR
} ERR_CODE;
// Generated by CIN in LabVIEW (CIN Source File .c)
typedef struct 
{
	int dimSize;		// array dimension
	int COM[1];			// array elements
} TD1;
typedef TD1 **TD1Hdl;

HANDLE	hPort;
char*   sPortName;

/* local functions */
ERR_CODE PortInitialize(char* lpszPortName, pSerialCreate pCreate);

//CINSetup() CIN Function
MgErr CINRun(TD1Hdl PortSettings, int32 *PortHandle, int32 *flg);

#ifdef __cplusplus
}
#endif  /* __cplusplus */
#endif