/****************************************************************************************
 * NAME		: LabVIEWSerialDLL.h
 * DESC.	: Header file for LabVIEWSerialDLL.cpp
 * PGRMER.	: Y. Bai
 * DATE		: 10/30/2003
 ***************************************************************************************/
#include <Windows.h>
#ifndef _LABVIEWSERIALDLL_H_
#define _LABVIEWSERIALDLL_H_

#define MAX_STRING				256
#define NOPARITY				0
#define ONESTOPBIT				0
#define RTS_CONTROL_DISABLE     0x00
#define RTS_CONTROL_ENABLE      0x01
#define DTR_CONTROL_DISABLE     0x00
#define DTR_CONTROL_ENABLE      0x01

#define UCHAR		unsigned char
#define ULONG		unsigned long
#define msg(info)	MessageBox(NULL, info, "", MB_OK)

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
typedef struct
{
    ULONG   ulCtrlID;
    char    cEcho;
    char    cEORChar;
    long    lTimeout;
    long    lBaudRate;
    long    lDataBits;
} SerialCreate, *pSerialCreate;
		
typedef struct
{
    UCHAR pcBuffer;           /* added */
    int   iMaxChars;          /* added */
	int   iMaxBits;           /* added */
    int   piNumRcvd;          /* added */
	char  cTermChar;		  /* added */
} CommPortClass;

typedef enum
{
    OK          = 0,		 /* no error */
    EC_TIMEOUT,
	EC_FOPEN,
	EC_INVAL_CONFIG,
	EC_TIMEOUT_SET,
	EC_RECV_TIMEOUT,
	EC_EXIT_CODE,
	EC_WAIT_SINGLEOBJ,
	EC_INVALIDPORT,
	EC_WRITE_FAIL,
	EC_CREATE_THREAD,
	EC_GETMODSTATUS,
	EC_UNKNOWNERROR
} ERR_CODE;

FILE*   fp;
HANDLE	hPort;
char*   sPortName;
bool    PortCreateflg = false;

/* local functions */
ERR_CODE PortInitialize(char* lpszPortName, pSerialCreate pCreate);
ERR_CODE PortRead(CommPortClass *hCommPort);
ERR_CODE PortWrite(char* bByte, int NumByte);
void  delay(int period);
/*---------------------------------------------------------------------*/
#define DllExport   __declspec( dllexport ) 
/*---------------------------------------------------------------------*/
DllExport long Setup(long comParms[]);
DllExport UCHAR ReadByte(void);
DllExport long Close();
#ifdef __cplusplus
}
#endif  /* __cplusplus */
#endif