function out = OpenPort(comPort)
%OPENPORT M-Code for creating an instrument object.
%    
%    This is the machine generated representation of an instrument object.
%    This M-file, OPENPORT.M, was generated from the OBJ2MFILE function.
%    A MAT-file is created if the object's UserData property is not 
%    empty or if any of the callback properties are set to a cell array  
%    or to a function handle. The MAT-file will have the same name as the 
%    M-file but with a .MAT extension. To recreate this instrument object,
%    type the name of the M-file, SimpleCom, at the MATLAB command prompt.
%    
%    The M-file, OPENPORT.M and its associated MAT-file, OPENPORT.MAT (if 
%    it exists) must be on your MATLAB PATH. For additional information
%    on setting your MATLAB PATH, type 'help addpath' at the MATLAB 
%    command prompt.
%    
%    Example: 
%       obj = OpenPort;
%    
%    See also SERIAL, GPIB, VISA, TCPIP, UDP, INSTRHELP, INSTRUMENT/PROPINFO.
%    

%    Creation time: 16-Nov-2003 11:27:52

% Create the instrument object.
obj1 = serial(comPort);

% Set the property values.
set(obj1, 'BaudRate', 9600);
set(obj1, 'BreakInterruptFcn', '');
set(obj1, 'ByteOrder', 'littleEndian');
set(obj1, 'BytesAvailableFcn', '');
set(obj1, 'BytesAvailableFcnCount', 8);
set(obj1, 'BytesAvailableFcnMode', 'byte');
set(obj1, 'DataBits', 8);
set(obj1, 'DataTerminalReady', 'on');
set(obj1, 'ErrorFcn', '');
set(obj1, 'FlowControl', 'none');
set(obj1, 'InputBufferSize', 512);
set(obj1, 'Name', comPort);
set(obj1, 'OutputBufferSize', 512);
set(obj1, 'OutputEmptyFcn', '');
set(obj1, 'Parity', 'none');
set(obj1, 'PinStatusFcn', '');
set(obj1, 'Port', comPort);
set(obj1, 'ReadAsyncMode', 'continuous');
set(obj1, 'RecordDetail', 'compact');
set(obj1, 'RecordMode', 'overwrite');
set(obj1, 'RecordName', 'record.txt');
set(obj1, 'RequestToSend', 'on');
set(obj1, 'StopBits', 1);
set(obj1, 'Tag', '');
set(obj1, 'Terminator', 'LF');
set(obj1, 'Timeout', 10);
set(obj1, 'TimerFcn', '');
set(obj1, 'TimerPeriod', 1);
set(obj1, 'UserData', []);

if nargout > 0 
    out = [obj1]; 
end




