% Load shared library MAXDLL.dll
% The header file MAXDLL.h is at C:\Book2_Program\Chapter 6\MAXDLL
% The shared library file MAXDLL.dll is at the current folder - work
% November 26, 2003
% Y. Bai
V = 5.0;            % MAX187 full input voltage is 5.0 V.
S = 4095;           % 12-bit scalar factor is 4095.
N = 100;
PortNum  = 1;
max_data = zeros(1, 100);
BaudRate = 9600;
DataBits = 8;
StopBits = 1;
Parity   = 0;
Timeout  = 5000;
comPort = [PortNum BaudRate DataBits StopBits Parity Timeout];
hfile = ['C:\Book2_Program\Chapter 6\MAXDLL\MAXDLL.h'];
loadlibrary('MAXDLL', hfile);
libfunctions MAXDLL -full
ret = calllib('MAXDLL', 'Setup', comPort);
if ret ~= 0
    ERROR('Error in Setup() calling...');
end
max_data(1) = calllib('MAXDLL', 'ReadData');    %wake-up reading
for m = 1:N,
    max_data(m) = calllib('MAXDLL', 'ReadData');
end
ret = calllib('MAXDLL', 'PortClose');
if ret ~= 0 
    ERROR('Error in PortClose() calling...');
end
max_data = max_data * V/S;
t = 1:N;
plot(t, max_data, 'b-', t, max_data, 'b.');
grid;
title('LOAD DLL MAXDLL: - Interface to Serial A/D Converter - MAX187');
xlabel('Sampling Points - 100 pt.');
ylabel('Real Amplitude');

unloadlibrary MAXDLL


