/****************************************************************************************
 * NAME		: MEX_MAX.h
 * DESC.	: Header file for MEX_MAX.cpp (MAX187 A/D Converter)
 * PGRMER.	: Y. Bai
 * DATE		: 11/21/2003
 ***************************************************************************************/
#include <Windows.h>
#include "mex.h"
#ifndef _MEX_MAX_H_
#define _MEX_MAX_H_

#define MAX_BYTE				1
#define MAX_BITS				12	
#define MAX_DATA				100
#define MAX_STRING				256
#define NOPARITY				0
#define ONESTOPBIT				0
#define RTS_CONTROL_DISABLE     0x00
#define RTS_CONTROL_ENABLE      0x01
#define DTR_CONTROL_DISABLE     0x00
#define DTR_CONTROL_ENABLE      0x01

#define msg(info)	MessageBox(NULL, info, "", MB_OK)

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
typedef struct
{
    ULONG   ulCtrlID;
    char    cEcho;
    char    cEORChar;
    long    lTimeout;
    long    lBaudRate;
    long    lDataBits;
} SerialCreate, *pSerialCreate;
		
typedef struct
{
    int   pcBuffer;           /* received data buffer */
    int   iMaxChars;          /* the number of the maximum characters */
	int   iMaxBits;           /* the number of the maximum bits */
    int   piNumRcvd;          /* the number of the received data */
	char  cTermChar;		  /* the termination character */
} CommPortClass;

typedef enum
{
    OK          = 0,		 /* no error */
    EC_TIMEOUT,
	EC_FOPEN,
	EC_INVAL_CONFIG,
	EC_TIMEOUT_SET,
	EC_RECV_TIMEOUT,
	EC_EXIT_CODE,
	EC_WAIT_SINGLEOBJ,
	EC_INVALIDPORT,
	EC_WRITE_FAIL,
	EC_CREATE_THREAD,
	EC_GETMODSTATUS,
	EC_UNKNOWNERROR
} ERR_CODE;

FILE*   fp;
HANDLE	hPort;
char*   sPortName;
bool    PortCreateflg = false;
int     runTIMES = 0;

/* local functions */
int   Setup(double* pCom);
int   ReadData(void);
int   PortClose();
void  WINAPI ThreadFunc(void* hCommPorts);
void  Delay(int num);
void  mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray*prhs[]);
ERR_CODE PortInitialize(char* lpszPortName, pSerialCreate pCreate);
ERR_CODE PortRead(CommPortClass *hCommPort);

#ifdef __cplusplus
}
#endif  /* __cplusplus */
#endif