/****************************************************************************************
 * NAME		: MEX_TLC.h
 * DESC.	: Header file for MEX_TLC.cpp
 * PGRMER.	: Y. Bai
 * DATE		: 11/20/2003
 ***************************************************************************************/
#include <Windows.h>
#include "mex.h"
#ifndef _MEX_TLC_H_
#define _MEX_TLC_H_

#define MAXBYTES				100
#define MAX_STRING				256
#define NOPARITY				0
#define ONESTOPBIT				0
#define RTS_CONTROL_DISABLE     0x00
#define RTS_CONTROL_ENABLE      0x01
#define DTR_CONTROL_DISABLE     0x00
#define DTR_CONTROL_ENABLE      0x01

#define UCHAR		unsigned char
#define ULONG		unsigned long
#define msg(info)	MessageBox(NULL, info, "", MB_OK)

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
typedef struct
{
    ULONG   ulCtrlID;
    char    cEcho;
    char    cEORChar;
    long    lTimeout;
    long    lBaudRate;
    long    lDataBits;
} SerialCreate, *pSerialCreate;
		
typedef struct
{
    UCHAR pcBuffer;           /* received data buffer */
    int   iMaxChars;          /* the number of the maximum characters */
	int   iMaxBits;           /* the number of the maximum bits */
    int   piNumRcvd;          /* the number of the received data */
	char  cTermChar;		  /* the termination character */
} CommPortClass;

typedef enum
{
    OK          = 0,		 /* no error */
    EC_TIMEOUT,
	EC_FOPEN,
	EC_INVAL_CONFIG,
	EC_TIMEOUT_SET,
	EC_RECV_TIMEOUT,
	EC_EXIT_CODE,
	EC_WAIT_SINGLEOBJ,
	EC_INVALIDPORT,
	EC_WRITE_FAIL,
	EC_CREATE_THREAD,
	EC_GETMODSTATUS,
	EC_UNKNOWNERROR
} ERR_CODE;

FILE*   fp;
HANDLE	hPort;
char*   sPortName;
bool    PortCreateflg = false;

/* local functions */
int   Setup(double* pCom);
UCHAR ReadByte(void);
int   PortClose();
void  delay(int period);
void  mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray*prhs[]);
ERR_CODE PortInitialize(char* lpszPortName, pSerialCreate pCreate);
ERR_CODE PortRead(CommPortClass *hCommPort);
ERR_CODE PortWrite(char* bByte, int NumByte);
#ifdef __cplusplus
}
#endif  /* __cplusplus */
#endif