/****************************************************************************************
 * NAME		: JNIMAX.h
 * DESC.	: Header file for JNIMAX.cpp (MAX187 A/D Converter) 
 * PGRMER.	: Y. Bai
 * DATE		: 12/18/2003
 ***************************************************************************************/
#include <windows.h>
#ifndef _JNIMAX_H_
#define _JNIMAX_H_

#define MAX_BYTE				1
#define MAX_BITS				12	
#define MAX_DATA				100
#define MAX_STRING				256
#define NOPARITY				0
#define RTS_CONTROL_DISABLE     0x00
#define RTS_CONTROL_ENABLE      0x01
#define DTR_CONTROL_DISABLE     0x00
#define DTR_CONTROL_ENABLE      0x01

#define msg(info)	MessageBox(NULL, info, "", MB_OK)

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
typedef struct
{
    ULONG   ulCtrlID;
    char    cEcho;
    char    cEORChar;
    long    lTimeout;
    long    lBaudRate;
    long    lDataBits;
} SerialCreate, *pSerialCreate;
		
typedef struct
{
    int   pcBuffer;           /* received data buffer */
    int   iMaxChars;          /* the number of the maximum characters */
	int   iMaxBits;           /* the number of the maximum bits */
    int   piNumRcvd;          /* the number of the received data */
	char  cTermChar;		  /* the termination character */
} CommPortClass;

typedef enum
{
    OK          = 0,		 /* no error */
    EC_TIMEOUT,
	EC_FOPEN,
	EC_INVAL_CONFIG,
	EC_TIMEOUT_SET,
	EC_RECV_TIMEOUT,
	EC_EXIT_CODE,
	EC_WAIT_SINGLEOBJ,
	EC_INVALIDPORT,
	EC_WRITE_FAIL,
	EC_CREATE_THREAD,
	EC_GETMODSTATUS,
	EC_UNKNOWNERROR
} ERR_CODE;

FILE*   fp;
HANDLE	hPort;
char*   sPortName;
bool    PortCreateflg = false;
int     runTIMES = 0;
/* Local functions */
ERR_CODE PortInitialize(char* lpszPortName, pSerialCreate pCreate);
ERR_CODE PortRead(CommPortClass *hCommPort);
void     WINAPI ThreadFunc(void* hCommPorts);
void     Delay(int num);

#ifdef __cplusplus
}
#endif  /* __cplusplus */
#endif