/****************************************************************************************
 * NAME		: JNISerial.h
 * DESC.	: Header file for JNISerial.cpp
 * PGRMER.	: Y. Bai
 * DATE		: 12/16/2003
 ***************************************************************************************/
#include <windows.h>
#ifndef _JNISERIAL_H_
#define _JNISERIAL_H_

#define MAX_STRING				256
#define NOPARITY				0
#define RTS_CONTROL_DISABLE     0x00
#define RTS_CONTROL_ENABLE      0x01
#define DTR_CONTROL_DISABLE     0x00
#define DTR_CONTROL_ENABLE      0x01

#define msg(info)	MessageBox(NULL, info, "", MB_OK)

typedef struct
{
    unsigned long   ulCtrlerID;
    char            cEcho;
    char            cEORChar;
    long            lTimeout;
    long            lBaudRate;
    long            lDataBits;
} SerialCreate, *pSerialCreate;
		
typedef struct
{
    char pcBuffer[8];        /* data buffer */
    int  iMaxChars;          /* max characters */
    int  piNumRcvd;          /* number of data received */
	char cTermChar;			 /* terminator */
} CommPortClass;

typedef enum
{
    OK          = 0,		 /* no error */
    EC_TIMEOUT,
	EC_FOPEN,
	EC_INVAL_CONFIG,
	EC_TIMEOUT_SET,
	EC_RECV_TIMEOUT,
	EC_EXIT_CODE,
	EC_WAIT_SINGLEOBJ,
	EC_INVALIDPORT,
	EC_WRITE_FAIL,
	EC_CREATE_THREAD,
	EC_UNKNOWNERROR
} ERR_CODE;

HANDLE	hPort;
char*   sPortName;
bool    PortCreateflg = false;

/* local functions */
ERR_CODE PortInitialize(LPTSTR lpszPortName, pSerialCreate pCreate);
ERR_CODE PortWrite(char* bByte, int NumByte);
ERR_CODE PortRead(CommPortClass *hCommPort);
void WINAPI ThreadFunc(void* hCommPorts);

#endif