/*******************************************************************************
 * NAME	: JSerialGUI.java
 * DESC	: Java GUI file to test a serial port
 * DATE	: 12/15/2003
 ******************************************************************************/
import java.awt.*;
import java.awt.event.*;

public class JSerialGUI extends Frame implements ActionListener
{
    Button bSetup  = new Button("Setup");
    Button bTest   = new Button("Test");
    Button bExit   = new Button("Exit");

    JSerialCreate serial = new JSerialCreate();

    public JSerialGUI()
    {
	super("Java Serial Port Testing GUI");

	bExit.addActionListener(this);
	bSetup.addActionListener(this);
	bTest.addActionListener(this);
	setSize(450, 250);
	setLayout(new BorderLayout(2, 7));	

	Panel paneW = new Panel();
	paneW.setLayout(new GridLayout(5, 5, 8, 8));
	paneW.add(serial.lcomPort);
	paneW.add(serial.tcomPort);
	paneW.add(serial.lbaudRate);
	paneW.add(serial.tbaudRate);
	paneW.add(serial.ldataBits);
	paneW.add(serial.tdataBits);
	paneW.add(serial.lstopBit);
	paneW.add(serial.tstopBit);
	paneW.add(serial.lparity);
	paneW.add(serial.tparity);
	add(paneW, "West");
	Panel paneE = new Panel();
	paneE.setLayout(new GridLayout(5, 5, 8, 8));
	paneE.add(serial.lNum);
	paneE.add(serial.tNum);
	paneE.add(serial.lOft);
	paneE.add(serial.tOft);
	paneE.add(serial.lSend);
	paneE.add(serial.tSend);
	paneE.add(serial.lRead);
	paneE.add(serial.tRead);
	add(paneE, "East");

	Panel paneN = new Panel();
	paneN.setBackground(Color.gray);
	paneN.add(new Label("Welcome to Java Serial Port Testing "));
	add(paneN, "North");
	
	Panel paneS = new Panel();
	paneS.setBackground(Color.gray);
	paneS.add(bSetup);
	paneS.add(bTest);
	paneS.add(bExit);
	add(paneS, "South");
    }

    public void actionPerformed(ActionEvent evt)
    {
	int m, n, ret = 0, rndNum = 0, rndOft = 0;
        int comPrms[] = {1, 9600, 8, 1, 0};

	JavaSerial jserial = new JavaSerial();

	rndNum = serial.getNum(serial.tNum.getText());
	rndOft = serial.getNum(serial.tOft.getText());
	Object src = evt.getSource();
	if (src == bExit)
	{
	   ret = jserial.JavaClose();
	   System.exit(0);
	}
	if (src == bSetup)
	{
	   if (rndNum == 0)
	      return;
	   comPrms[0] = serial.getNum(serial.tcomPort.getText());
	   comPrms[1] = serial.getNum(serial.tbaudRate.getText());
	   comPrms[2] = serial.getNum(serial.tdataBits.getText());
	   comPrms[3] = serial.getNum(serial.tstopBit.getText());
	   comPrms[4] = serial.getNum(serial.tparity.getText());
	   ret = jserial.JavaSetup(comPrms);
	}
	if (src == bTest)
	{
	   for (m = 1; m <= rndNum; m++)
	   {
	       n = m + rndOft;
	       ret = jserial.JavaWrite(n);
	       if (ret != 0)
	       {
		  msg warn = new msg("ERROR in Write() DLL Calling");
	   	  warn.show();
                  return;
               }
	       serial.tSend.setText(serial.getStr(n));
	       ret = jserial.JavaRead();
	       serial.tRead.setText(serial.getStr(ret));
	       if (ret != n)
	       {
		  msg warn = new msg("ERROR in the Port Testing");
	   	  warn.show();
                  return;
               }
	   }
	}
    }
    public static void main(String[] args)
    {
	JSerialGUI sGUI = new JSerialGUI();
	sGUI.show();
    }
}












